%set_verify_elf_skiplist %_libdir/epiphany/*/extensions/libbeagleextension.so
%def_enable epiphany
%def_enable python
%def_enable evolution
%def_enable sqlite3
%def_enable xss
%def_disable thunderbird
%def_enable gui
%def_enable libbeagle

Name: beagle
Version: 0.2.16.3
Release: alt1
Summary: The Beagle Search Infrastructure
Group: Graphical desktop/GNOME
License: LGPL
Url: http://beagle-project.org/
Source0: %name-%version.tar.bz2
Requires: sqlite3 libXScrnSaver libexif
Requires: mono mono-data-sqlite libgmime-sharp libgsf-sharp  libgnome-sharp  kdelibs
Requires: zip unzip sed grep

BuildRequires: gcc-c++ imake kdelibs libgalago-sharp libgmime-sharp libsqlite3-devel
BuildRequires: libgtk-sharp2-devel libgtk-sharp2-gapi libgnome-sharp-devel libchm-devel
BuildRequires: libgnome-sharp libgsf-devel libgsf-sharp librsvg-devel libSM-devel libwv-devel 
BuildRequires: libXScrnSaver-devel mono-data-sqlite mono-mcs mono-web packages-info-i18n-common 
BuildRequires: perl-XML-Parser xorg-cf-files zip libexif-devel ImageMagick
BuildRequires: libchm-devel gtk-doc
BuildPreReq: rpm-build-mono
BuildRequires: /proc

PreReq: shadow-utils

Patch3: beagle-log-level-warn.patch
Patch4: beagle-crawl-config.patch
Patch10: beagle-link-python.patch
Patch11: beagle-0.2.16.2-fix-epiphany-2.18.patch

%description
A general infrastructure for making your data easy to find.

%if_enabled gui
%package gui
Summary: Beagle search system user interface
Group: Graphical desktop/GNOME
Requires: beagle = %version-%release

%description gui
User interface for doing beagle searches
%endif

%if_enabled evolution
%package evolution
Summary: Beagle backend for evolution
Group: Graphical desktop/GNOME
Requires: %name-gui = %version-%release
Requires: libevolution-sharp 
BuildRequires: libevolution-sharp-devel

%description evolution
Beagle indexing backend for evolution
%endif

%if_enabled libbeagle
%package -n lib%name
Summary: Beagle C interface
Group: System/Libraries

%description -n lib%name
Library to talk to the beagle server in C.

%package -n lib%name-devel
Summary: Beagle C interface
Group: Development/C
Requires: lib%name = %version-%release libxml2-devel glib2-devel
Requires: pkgconfig

%description -n lib%name-devel
Library to talk to the beagle server in C.
%endif

%if_enabled python
%package -n lib%name-python
Summary: Beagle python interface
Group: Development/Python
Requires: lib%name = %version-%release
Requires: python-module-pygtk
BuildRequires: python-dev python-module-pygtk-devel python-modules-encodings  python-modules-compiler  python-modules

%description -n lib%name-python
Python wrappers for libbeagle
%endif

%if_enabled epiphany
%package -n epiphany-extension-%name
Summary: Epiphany extension for Beagle
Group: Networking/WWW
Requires: beagle = %version-%release
Requires: epiphany-extensions
BuildRequires: epiphany-devel epiphany-extensions

%description -n epiphany-extension-%name
This is an Epiphany extension that allows Beagle to index every page
the user views.  The code is derived from Dashboard's extension.

Right now, this extension is just a hack: for every page, Epiphany tries to
run a program named 'beagle-epiphany-index'.  The page's URI and title are
passed to beagle-epiphany-index as command-line arguments, and the HTML is
written to its stdin.

Obviously this opens up a huge security hole: anyone who can get a rogue
program named 'beagle-epiphany-index' into the user's path can spy on all of
their web traffic.

There is also the issue of private information (account numbers, etc.) ending
up in the index.  To try to avoid this, beagle-epiphany-index will not index
https:// URIs.
%endif

%package crawl-system
Group: System/Servers
Summary: Indexing subsystem for system files
Requires: %name = %version

%description crawl-system
Beagle is an indexing sub-system and search aggregator built on top of
Lucene.Net.
Install this to automatically index your system files.


%prep
%setup -q
%patch3 -p0
%patch4 -p1 
%patch10 -p1
%patch11 -p1

%build
%__autoreconf
%configure \
    %{subst_enable python} \
%if_enabled epiphany
    --enable-epiphany-extension \
    --enable-epiphany-extension-install \
%endif
     %{subst_enable evolution} \
     %{subst_enable sqlite3} \
     %{subst_enable xss} \
     %{subst_enable thunderbird} \
     %{subst_enable gui} \
     %{subst_enable libbeagle} \
     --enable-network \
     --enable-webservices \
     --enable-gtk-doc \
     --localstatedir=%_var
%_make_bin clean
%make_build

%install
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
%make_install install DESTDIR=%buildroot
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL

%__mkdir_p %buildroot/var/cache/beagle/indexes

desktop-file-install --vendor gnome --delete-original		\
  --dir %buildroot%_datadir/applications			\
  --remove-category="Application" 				\
  --add-category="System" 					\
  %buildroot%_datadir/applications/beagle-search.desktop

desktop-file-install --vendor gnome --delete-original		\
  --dir %buildroot%_datadir/applications			\
  --remove-category="Application" 				\
  --remove-category="AdvancedSettings"				\
  --add-category="DesktopSettings;GNOME"			\
  --remove-category Utility                                     \
  %buildroot%_datadir/applications/beagle-settings.desktop

#icons 
%__mkdir_p %buildroot{%_liconsdir,%_iconsdir,%_miconsdir}
convert -scale 48 images/system-search.png %buildroot%_liconsdir/system-search.png
convert -scale 32 images/system-search.png %buildroot%_iconsdir/system-search.png
convert -scale 16 images/system-search.png %buildroot%_miconsdir/system-search.png

# echo "NoDisplay=true" >> %buildroot%_datadir/applications/gnome-beagle-search.desktop

echo "Type=Application" >> %buildroot%_sysconfdir/xdg/autostart/beagle-search-autostart.desktop
echo "Type=Application" >> %buildroot%_sysconfdir/xdg/autostart/beagled-autostart.desktop

# %__sed -i -e 's@Icon=tango-system-search@Icon=gnome-search-tool@' %buildroot%_datadir/applications/gnome-beagle-search.desktop

%find_lang --with-gnome %name

%__rm -f %buildroot%_libdir/beagle/*.{a,la}
%__rm -f %buildroot%_libdir/gtk-2.0/*/filesystems/*.{a,la}
%__rm -f %buildroot%_libdir/*.{a,la}
%__rm -f %buildroot%_libdir/python*/site-packages/*.{a,la}

%if_enabled epiphany
%__rm -f %buildroot%_libdir/epiphany/*/extensions/*.{a,la}
%endif

%pre
%_sbindir/useradd -r -n -d /var/cache/beagle -c "User for Beagle indexing" -s /sbin/nologin beagleindex 2>/dev/null ||:

%files -f %name.lang
%doc COPYING README NEWS AUTHORS ChangeLog
%config(noreplace) %_sysconfdir/xdg/autostart/beagled-autostart.desktop
%_bindir/beagle-config
%_bindir/beagled
%_bindir/beagle-exercise-file-system
%_bindir/beagle-extract-content
%_bindir/beagle-doc-extractor
%_bindir/beagle-index-info
%_bindir/beagle-index-url
%_bindir/beagle-info
%_bindir/beagle-ping
%_bindir/beagle-query
%_bindir/beagle-shutdown
%_bindir/beagle-status
%_sbindir/*
%_libdir/pkgconfig/beagle*.pc
%dir %_libdir/%name
%dir %_libdir/%name/Filters
%dir %_libdir/%name/Backends
%_libdir/%name/BeagleDaemonLib.dll*
%_libdir/%name/BeagleDaemonPlugins.dll*
%_libdir/%name/Beagle.dll*
%_libdir/%name/Util.dll*
%_libdir/%name/BeagleDaemon.exe*
%_libdir/%name/BuildIndex.exe*
%_libdir/%name/Config.exe*
%_libdir/%name/ExerciseFileSystem.exe*
%_libdir/%name/ExtractContent.exe*
%_libdir/%name/DocExtractor.exe*
%_libdir/%name/DumpIndex.exe*
%_libdir/%name/IndexHelper.exe*
%_libdir/%name/IndexWebContent.exe*
%_libdir/%name/Info.exe*
%_libdir/%name/ManageIndex.exe*
%_libdir/%name/Query.exe*
%_libdir/%name/Shutdown.exe*
%_libdir/%name/beagled-index-helper
%_libdir/%name/libbeagleglue*
%_libdir/%name/Filters/*

%if_enabled thunderbird
%_libdir/beagle/Backends/ThunderbirdBackends.dll*
%_libdir/%name/ContactViewer.exe*
%_bindir/beagle-contactviewer
%endif

%_datadir/beagle
%_datadir/pixmaps/*
%_mandir/*/*

%files gui
%_bindir/beagle-imlogviewer
%_bindir/beagle-search
%_bindir/beagle-settings
%_libdir/%name/Images.dll*
%_libdir/%name/UiUtil.dll*
%_libdir/%name/ImLogViewer.exe*
%_libdir/%name/Search.exe*
%_libdir/%name/Settings.exe*
%_libdir/%name/libbeagleuiglue*
%_datadir/applications/*
%_iconsdir/*.png
%_liconsdir/*
%_miconsdir/*
# %_datadir/gnome/autostart/*.desktop
%config(noreplace) %_sysconfdir/xdg/autostart/beagle-search-autostart.desktop

%files evolution
%_libdir/beagle/Backends/EvolutionBackends.dll*

%files -n lib%name
%_libdir/lib%name.so.*

%files -n lib%name-devel
%_includedir/lib%name
%_libdir/lib%name.so
%_libdir/pkgconfig/libbeagle*.pc
%doc %_datadir/gtk-doc/html/*

%if_enabled python
%files -n lib%name-python
%_libdir/python*/site-packages/beagle.so
%endif

%if_enabled epiphany
%files -n epiphany-extension-%name
%_libdir/epiphany/*/extensions/*
%endif

%files crawl-system
%dir %_sysconfdir/beagle
%config(noreplace) %_sysconfdir/beagle/*
%config(noreplace) %_sysconfdir/cron.daily/beagle-crawl-system
#%_libexecdir/beagle-crawl-system 
%dir %attr(755,beagleindex,root) %_var/cache/beagle
%dir %attr(755,beagleindex,root) %_var/cache/beagle/indexes


%changelog
* Mon Apr 02 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.16.3-alt1
- 0.2.16.3
- fix build with epiphany 2.18
- remove beagle-0.2.10-xconnection-exit.patch (in upstream)

* Mon Mar 05 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.16-alt2
- rebuild with new wv-1.2.4

* Tue Feb 13 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.16-alt1
- 0.2.16

* Thu Feb 01 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.15.1-alt1
- 0.2.15.1
- disable build broken Thunderbird backend

* Fri Dec 15 2006 Alexey Shabalin <shaba@altlinux.ru> 0.2.14-alt1
- 0.2.14
- use included autostart desktop entries in /etc/xdg/autostart
- move autostart beagled in beagle package
- remove SOURCE1 and SOURCE2 (desktop files)
- add crawl-system package
- update beagle-crawl-config.patch and beagle-log-level-warn.patch
- noreplace for config files in /etc
- add gtk-doc in libbegle-devel
- add in BuildRequires libchm-devel
- add "make clean" in build section (bad source beagle tar.bz2)

* Thu Dec 14 2006 Alexey Shabalin <shaba@altlinux.ru> 0.2.13-alt1
- move autostart to beagle-gui
- move autostart beagled from /etc/xdg/autostart to /usr/share/gnome/autostart 
  for KDE use "kerry"
- add autostart beagle-search tray icon
- cleanup spec

* Tue Oct 31 2006 Alexey Shabalin <shaba@altlinux.ru> 0.2.13-alt0.1
- first build for ALT Linux.
- adaptation spec from RH
- build firefox extension from another source package
